--- apt-file.orig	2007-10-28 15:45:12.000000000 +0300
+++ apt-file	2007-10-28 15:51:33.000000000 +0300
@@ -8,32 +8,34 @@
 	prev=${COMP_WORDS[COMP_CWORD-1]}
 
 	for (( i=0; i < ${#COMP_WORDS}-1; i++ )); do
-		if [[ ${COMP_WORDS[i]} == @(list) ]]; then
-			special=${COMP_WORDS[i]}
-		fi
+		case ${COMP_WORDS[i]} in
+		    update|search|list|show|purge)
+		        special=${COMP_WORDS[i]}
+			break
+			;;
+		esac
 	done
 
-	if [ -n "$special" ]; then
-            COMPREPLY=( $( apt-cache pkgnames $cur 2> /dev/null ) )
-            return 0
-        fi
-
 	if [[ "$cur" == -* ]]; then
 
 		COMPREPLY=( $( compgen -W '-c -v -V -a -s -l -F -y -H \
 				--cache --verbose --version --architecture \
 				--sources-list --package-only --fixed-string \
 				--dummy --help' -- $cur ) )
+	elif [ -n "$special" ]; then
+		case $special in
+		    list|show)
+			COMPREPLY=( $( apt-cache pkgnames $cur 2> /dev/null ) )
+			;;
+		    search)
+			_filedir
+			;;
+		esac
 	else
 
 		COMPREPLY=( $( compgen -W 'update search list \
                                 show purge' -- $cur ) )
 
 	fi
-
-
-	return 0
-
 }
-complete -F _apt-file apt-file
-
+complete -F _apt-file $filenames apt-file
